Subject: bug#69404: Loss of latex-mode fontification when loading libraries in latex-mode-hook that require json-mode

From: Eli Zaretskii <[email-masked]>
Date: Mon, 26 Feb 2024 17:57:07 +0200

> Date: Mon, 26 Feb 2024 16:41:15 +0100
> Cc: [email-masked]
> From: Gabriele Nicolardi <[email-masked]>
> 
> 
> Il 26/02/24 14:03, Eli Zaretskii ha scritto:
> >> If I load my .tex file like this:
> >>
> >> emacs -Q --eval "(load-file \"/tmp/config.el\")" test.tex
> >>
> >> I lose latex-mode fontification:
> > What is the value of major-mode after you load your .tex file as
> > above?
> 
> In the buffer loaded as above, with the wrong fontification, I have:
> 
> major-mode is a variable defined in ‘C source code’.
> 
> 
> Its value is ‘latex-mode’
> Original value was ‘fundamental-mode’
> Local in buffer test.tex; global value is fundamental-mode

Then I suggest to look for the reason in json-mode.el.  For example,
this part:

  (add-to-list 'magic-fallback-mode-alist '("^[{[]$" . json-mode))

could change the global state when you load json-mode.